/*

fraction_sum_search.js

DESC:

A brute-force solution to the problem: what permutation of the digits from 1 to 9 will add to 1 when arranged in a form similar to 1/23 + 4/56 + 7/89 ?

RUN:

nodejs fraction_sum_search.js
[ 5, 3, 4, 7, 6, 8, 9, 1, 2 ]
[ 5, 3, 4, 9, 1, 2, 7, 6, 8 ]
[ 7, 6, 8, 5, 3, 4, 9, 1, 2 ]
[ 7, 6, 8, 9, 1, 2, 5, 3, 4 ]
[ 9, 1, 2, 5, 3, 4, 7, 6, 8 ]
[ 9, 1, 2, 7, 6, 8, 5, 3, 4 ]
Execution time: 703ms

*/

var permArr = [],usedChars = [];

function permute(input) {
  var i, ch;
  for (i = 0; i < input.length; i++) {
    ch = input.splice(i, 1)[0];
    usedChars.push(ch);
    if (input.length == 0) {
      permArr.push(usedChars.slice());
    }
    permute(input);
    input.splice(i, 0, ch);
    usedChars.pop();
  }
  return permArr
};

function cc(x,y) {
  return x*10+y;
}

console.time("Execution time");

var a = [];
for (var i = 1; i <= 9; i++) {
    a.push(i);
}

perms = permute(a);

for (var i = 0; i < perms.length; i++) {
  if (perms[i][0]/cc(perms[i][1],perms[i][2])+perms[i][3]/cc(perms[i][4],perms[i][5])+perms[i][6]/cc(perms[i][7],perms[i][8])==1){
    console.log(perms[i])
  }
}

console.timeEnd("Execution time");
