import itertools 
import time

class Permuter(object):
	"""docstring for ClassName"""
	def __init__(self, r):
		super(Permuter, self).__init__()
		self.r = r
		self.p = itertools.permutations(self.r)

	def next(self):
		return self.p.next()

	def perms(self):
		return self.p

	def listAll(self):
		return list(itertools.permutations(self.r))

def cc(x, y):
    return x*10+y

t = time.time()

p = Permuter(range(1,10))
	
results = []

for l in p.listAll():
	if (float(l[0])/cc(l[1],l[2])+float(l[3])/cc(l[4],l[5])+float(l[6])/cc(l[7],l[8])==1):
		results.append(l)

print(results) 

print("Execution time {} seconds.".format(time.time()-t))