#define _GNU_SOURCE
#include <dlfcn.h>
#include <stdio.h>
#include <string.h>

static int (*real_puts)(const char* str) = NULL;

int puts(const char* str){

    /* printing out the number of characters */
    printf("puts:chars#:%lu\n", strlen(str));

    /* resolve the real puts function from glibc
     * and pass the arguments.
     */
    real_puts = dlsym(RTLD_NEXT, "puts");
    real_puts(str);
}